-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Form - Grouping
Backend API
$(() => {
function groupCaptionTemplate($icon) {
return (data) => $(
`<i class='dx-icon dx-icon-${$icon}'></i><span>${data.caption}</span>`,
);
}
$('#form').dxForm({
formData: employees,
colCount: 2,
items: [{
itemType: 'group',
captionTemplate: groupCaptionTemplate('info'),
caption: 'System Information',
items: ['ID', {
itemType: 'group',
captionTemplate: groupCaptionTemplate('user'),
caption: 'Main Information',
items: ['FirstName', 'LastName', 'HireDate', 'Position', 'OfficeNo'],
}],
}, {
itemType: 'group',
captionTemplate: groupCaptionTemplate('card'),
caption: 'Personal Data',
items: ['BirthDate', {
itemType: 'group',
captionTemplate: groupCaptionTemplate('home'),
caption: 'Home Address',
items: ['Address', 'City', 'State', 'Zipcode'],
}],
}, {
itemType: 'group',
captionTemplate: groupCaptionTemplate('tel'),
caption: 'Contact Information',
items: [{
itemType: 'tabbed',
tabPanelOptions: {
deferRendering: false,
},
tabs: [{
title: 'Phone',
items: ['Phone'],
}, {
title: 'Skype',
items: ['Skype'],
}, {
title: 'Email',
items: ['Email'],
}],
}],
}],
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.3"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="long-title"><h3>Personal details</h3></div>
<div id="form-container">
<div id="form"></div>
</div>
</div>
</body>
</html>
#form-container {
margin: 10px;
}
.long-title h3 {
font-size: 24px;
text-align: center;
line-height: 2em;
}
.dx-form-group-custom-caption .dx-icon {
color: var(--dx-color-spin-icon);
}
.dx-form-group-custom-caption span {
line-height: 1;
}
const employees = {
ID: 1,
FirstName: 'John',
LastName: 'Heart',
CompanyName: 'Super Mart of the West',
Position: 'CEO',
OfficeNo: '901',
BirthDate: new Date(1964, 2, 16),
HireDate: new Date(1995, 0, 15),
Address: '351 S Hill St.',
City: 'Los Angeles',
State: 'CA',
Zipcode: '90013',
Phone: '(213) 555-9392',
Email: 'jheart@dx-email.com',
Skype: 'jheart_DX_skype',
};
To create a group item, assign "group" to the itemType property. To specify a group's title, use the caption property. To replace a group's title with custom content, implement a caption template. This demo shows three groups. The Personal Data group is nested in the System Information group.
To create a tabbed item, assign "tabbed" to the itemType property. This demo shows a tabbed item nested in the Contact Information group. The JavaScript Form uses the TabPanel component to display tabs. You can specify the TabPanel's properties in the tabPanelOptions object. This demo disables the deferRendering property to render TabPanel's content immediately.

<div class="long-title">
<h3>Personal details</h3>
</div>
<div id="form-container">
<dx-form id="form" [formData]="employee" [colCount]="2">
<dxi-form-item
itemType="group"
captionTemplate="info"
caption="System Information"
>
<dxi-form-item dataField="ID"></dxi-form-item>
<dxi-form-item
itemType="group"
captionTemplate="user"
caption="Main Information"
>
<dxi-form-item dataField="FirstName"></dxi-form-item>
<dxi-form-item dataField="LastName"></dxi-form-item>
<dxi-form-item dataField="HireDate"></dxi-form-item>
<dxi-form-item dataField="Position"></dxi-form-item>
<dxi-form-item dataField="OfficeNo"></dxi-form-item>
</dxi-form-item>
</dxi-form-item>
<dxi-form-item
itemType="group"
captionTemplate="personal"
caption="Personal Data"
>
<dxi-form-item dataField="BirthDate"></dxi-form-item>
<dxi-form-item
itemType="group"
captionTemplate="address"
caption="Home Address"
>
<dxi-form-item dataField="Address"></dxi-form-item>
<dxi-form-item dataField="City"></dxi-form-item>
<dxi-form-item dataField="State"></dxi-form-item>
<dxi-form-item dataField="Zipcode"></dxi-form-item>
</dxi-form-item>
</dxi-form-item>
<dxi-form-item
itemType="group"
captionTemplate="contact"
caption="Contact Information"
>
<dxi-form-item itemType="tabbed">
<dxo-form-tab-panel-options [deferRendering]="false">
</dxo-form-tab-panel-options>
<dxi-form-tab title="Phone">
<dxi-form-item dataField="Phone"></dxi-form-item>
</dxi-form-tab>
<dxi-form-tab title="Skype">
<dxi-form-item dataField="Skype"></dxi-form-item>
</dxi-form-tab>
<dxi-form-tab title="Email">
<dxi-form-item dataField="Email"></dxi-form-item>
</dxi-form-tab>
</dxi-form-item>
</dxi-form-item>
@for (label of groupCaptionTemplates; track label.name) {
<ng-container>
<div *dxTemplate="let data of label.name">
<i class="dx-icon {{ label.icon }}"></i><span>{{ data.caption }}</span>
</div>
</ng-container>
}
</dx-form>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxFormModule } from 'devextreme-angular';
import { Employee, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxFormModule,
],
})
export class AppComponent {
employee: Employee;
groupCaptionTemplates: { name: string; icon: string }[];
constructor(service: Service) {
this.employee = service.getEmployee();
this.groupCaptionTemplates = [
{ name: 'user', icon: 'dx-icon-user' },
{ name: 'info', icon: 'dx-icon-info' },
{ name: 'personal', icon: 'dx-icon-card' },
{ name: 'address', icon: 'dx-icon-home' },
{ name: 'contact', icon: 'dx-icon-tel' },
];
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #form-container {
margin: 10px;
}
::ng-deep .long-title h3 {
font-size: 24px;
text-align: center;
line-height: 2em;
}
::ng-deep .dx-form-group-custom-caption .dx-template-wrapper {
display: flex;
align-items: center;
}
::ng-deep .dx-form-group-custom-caption .dx-icon {
color: var(--dx-color-spin-icon);
}
::ng-deep .dx-form-group-custom-caption span {
line-height: 1;
}
import { Injectable } from '@angular/core';
export class Employee {
ID: number;
FirstName: string;
LastName: string;
CompanyName: string;
Position: string;
OfficeNo: string;
BirthDate: Date;
HireDate: Date;
Address: string;
City: string;
State: string;
Zipcode: string;
Phone: string;
Email: string;
Skype: string;
}
const employee: Employee = {
ID: 1,
FirstName: 'John',
LastName: 'Heart',
CompanyName: 'Super Mart of the West',
Position: 'CEO',
OfficeNo: '901',
BirthDate: new Date(1964, 2, 16),
HireDate: new Date(1995, 0, 15),
Address: '351 S Hill St.',
City: 'Los Angeles',
State: 'CA',
Zipcode: '90013',
Phone: '(213) 555-9392',
Email: 'jheart@dx-email.com',
Skype: 'jheart_DX_skype',
};
@Injectable()
export class Service {
getEmployee(): Employee {
return employee;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import 'devextreme-react/text-area';
import Form, {
GroupItem,
SimpleItem,
Tab,
TabbedItem,
TabPanelOptions,
} from 'devextreme-react/form';
import GroupCaption from './GroupCaption.tsx';
import type { GroupCaptionProps } from './GroupCaption.tsx';
import { employee } from './data.ts';
const groupCaptionNamedRender = (iconName: string) =>
(data: GroupCaptionProps) => (
<GroupCaption
{...data}
iconName={iconName}
/>
);
export default function App() {
return (
<>
<div className="long-title"><h3>Personal details</h3></div>
<div className="form-container">
<Form
colCount={2}
id="form"
formData={employee}>
<GroupItem captionRender={groupCaptionNamedRender('info')} caption="System Information">
<SimpleItem dataField="ID" />
<GroupItem captionRender={groupCaptionNamedRender('user')} caption="Main Information">
<SimpleItem dataField="FirstName" />
<SimpleItem dataField="LastName" />
<SimpleItem dataField="HireDate" />
<SimpleItem dataField="Position" />
<SimpleItem dataField="OfficeNo" />
</GroupItem>
</GroupItem>
<GroupItem captionRender={groupCaptionNamedRender('card')} caption="Personal Data">
<SimpleItem dataField="BirthDate" />
<GroupItem captionRender={groupCaptionNamedRender('home')} caption='Home Address'>
<SimpleItem dataField="Address" />
<SimpleItem dataField="City" />
<SimpleItem dataField="State" />
<SimpleItem dataField="Zipcode" />
</GroupItem>
</GroupItem>
<GroupItem captionRender={groupCaptionNamedRender('tel')} caption="Contact Information">
<TabbedItem>
<TabPanelOptions deferRendering={false} />
<Tab title="Phone">
<SimpleItem dataField="Phone" />
</Tab>
<Tab title="Skype">
<SimpleItem dataField="Skype" />
</Tab>
<Tab title="Email">
<SimpleItem dataField="Email" />
</Tab>
</TabbedItem>
</GroupItem>
</Form>
</div>
</>
);
}
import React from 'react';
import 'devextreme-react/text-area';
import Form, {
GroupItem,
SimpleItem,
Tab,
TabbedItem,
TabPanelOptions,
} from 'devextreme-react/form';
import GroupCaption from './GroupCaption.js';
import { employee } from './data.js';
const groupCaptionNamedRender = (iconName) => (data) =>
(
<GroupCaption
{...data}
iconName={iconName}
/>
);
export default function App() {
return (
<>
<div className="long-title">
<h3>Personal details</h3>
</div>
<div className="form-container">
<Form
colCount={2}
id="form"
formData={employee}
>
<GroupItem
captionRender={groupCaptionNamedRender('info')}
caption="System Information"
>
<SimpleItem dataField="ID" />
<GroupItem
captionRender={groupCaptionNamedRender('user')}
caption="Main Information"
>
<SimpleItem dataField="FirstName" />
<SimpleItem dataField="LastName" />
<SimpleItem dataField="HireDate" />
<SimpleItem dataField="Position" />
<SimpleItem dataField="OfficeNo" />
</GroupItem>
</GroupItem>
<GroupItem
captionRender={groupCaptionNamedRender('card')}
caption="Personal Data"
>
<SimpleItem dataField="BirthDate" />
<GroupItem
captionRender={groupCaptionNamedRender('home')}
caption="Home Address"
>
<SimpleItem dataField="Address" />
<SimpleItem dataField="City" />
<SimpleItem dataField="State" />
<SimpleItem dataField="Zipcode" />
</GroupItem>
</GroupItem>
<GroupItem
captionRender={groupCaptionNamedRender('tel')}
caption="Contact Information"
>
<TabbedItem>
<TabPanelOptions deferRendering={false} />
<Tab title="Phone">
<SimpleItem dataField="Phone" />
</Tab>
<Tab title="Skype">
<SimpleItem dataField="Skype" />
</Tab>
<Tab title="Email">
<SimpleItem dataField="Email" />
</Tab>
</TabbedItem>
</GroupItem>
</Form>
</div>
</>
);
}
import React from 'react';
export interface GroupCaptionProps {
iconName: string;
caption: string;
}
const GroupCaption = ({ iconName, caption }: GroupCaptionProps) => (
<>
<i className={`dx-icon dx-icon-${iconName}`}></i>
<span>{caption}</span>
</>
);
export default GroupCaption;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { Employee } from './types.ts';
export const employee: Employee = {
ID: 1,
FirstName: 'John',
LastName: 'Heart',
CompanyName: 'Super Mart of the West',
Position: 'CEO',
OfficeNo: '901',
BirthDate: new Date(1964, 2, 16),
HireDate: new Date(1995, 0, 15),
Address: '351 S Hill St.',
City: 'Los Angeles',
State: 'CA',
Zipcode: '90013',
Phone: '(213) 555-9392',
Email: 'jheart@dx-email.com',
Skype: 'jheart_DX_skype',
};
export type Employee = {
ID: number;
FirstName: string;
LastName: string;
CompanyName: string;
Position: string;
OfficeNo: string;
BirthDate: Date;
HireDate: Date;
Address: string;
City: string;
State: string;
Zipcode: string;
Phone: string;
Email: string;
Skype: string;
};
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
const GroupCaption = ({ iconName, caption }) => (
<>
<i className={`dx-icon dx-icon-${iconName}`}></i>
<span>{caption}</span>
</>
);
export default GroupCaption;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const employee = {
ID: 1,
FirstName: 'John',
LastName: 'Heart',
CompanyName: 'Super Mart of the West',
Position: 'CEO',
OfficeNo: '901',
BirthDate: new Date(1964, 2, 16),
HireDate: new Date(1995, 0, 15),
Address: '351 S Hill St.',
City: 'Los Angeles',
State: 'CA',
Zipcode: '90013',
Phone: '(213) 555-9392',
Email: 'jheart@dx-email.com',
Skype: 'jheart_DX_skype',
};
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.form-container {
margin: 10px;
}
.long-title h3 {
font-size: 24px;
text-align: center;
line-height: 2em;
}
.dx-form-group-custom-caption .dx-icon {
color: var(--dx-color-spin-icon);
}
.dx-form-group-custom-caption span {
line-height: 1;
}

<template>
<div>
<div class="long-title"><h3>Personal details</h3></div>
<div id="form-container">
<DxForm
id="form"
:col-count="2"
:form-data="employee"
>
<DxGroupItem
caption-template="infoGroupCaption"
caption="System Information"
>
<DxSimpleItem
data-field="ID"
/>
<DxGroupItem
caption-template="userDataGroupCaption"
caption="Main Information"
>
<DxSimpleItem
data-field="FirstName"
/>
<DxSimpleItem
data-field="LastName"
/>
<DxSimpleItem
data-field="HireDate"
/>
<DxSimpleItem
data-field="Position"
/>
<DxSimpleItem
data-field="OfficeNo"
/>
</DxGroupItem>
</DxGroupItem>
<DxGroupItem
caption-template="personalDataGroupCaption"
caption="Personal Data"
>
<DxSimpleItem
data-field="BirthDate"
/>
<DxGroupItem
caption-template="addressGroupCaption"
caption="Home Address"
>
<DxSimpleItem
data-field="Address"
/>
<DxSimpleItem
data-field="City"
/>
<DxSimpleItem
data-field="State"
/>
<DxSimpleItem
data-field="Zipcode"
/>
</DxGroupItem>
</DxGroupItem>
<DxGroupItem
caption-template="contactInfoGroupCaption"
caption="Contact Information"
>
<DxTabbedItem>
<DxTabPanelOptions
:defer-rendering="false"
/>
<DxTab
title="Phone"
>
<DxSimpleItem
data-field="Phone"
/>
</DxTab>
<DxTab
title="Skype"
>
<DxSimpleItem
data-field="Skype"
/>
</DxTab>
<DxTab
title="Email"
>
<DxSimpleItem
data-field="Email"
/>
</DxTab>
</DxTabbedItem>
</DxGroupItem>
<template #userDataGroupCaption="{ data }">
<GroupCaption
:data="data"
icon="user"
/>
</template>
<template #personalDataGroupCaption="{ data }">
<GroupCaption
:data="data"
icon="card"
/>
</template>
<template #contactInfoGroupCaption="{ data }">
<GroupCaption
:data="data"
icon="tel"
/>
</template>
<template #addressGroupCaption="{ data }">
<GroupCaption
:data="data"
icon="home"
/>
</template>
<template #infoGroupCaption="{ data }">
<GroupCaption
:data="data"
/>
</template>
</DxForm>
</div>
</div>
</template>
<script setup lang="ts">
import {
DxForm, DxSimpleItem, DxGroupItem, DxTabbedItem, DxTabPanelOptions, DxTab,
} from 'devextreme-vue/form';
import service from './data.ts';
import GroupCaption from './GroupCaption.vue';
import 'devextreme-vue/text-area';
const employee = service.getEmployee();
</script>
<style scoped>
#form-container {
margin: 10px;
}
.long-title h3 {
font-size: 24px;
text-align: center;
line-height: 2em;
}
.dx-form-group-custom-caption .dx-icon {
color: var(--dx-color-spin-icon);
}
.dx-form-group-custom-caption span {
line-height: 1;
}
</style>
<template>
<i :class="`dx-icon dx-icon-${icon}`"/><span>{{ data.caption }}</span>
</template>
<script setup lang="ts">
withDefaults(defineProps<{
data?: Record<string, any>
icon?: string
}>(), {
data: () => ({} as Record<string, any>),
icon: 'info',
});
</script>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
const employee = {
ID: 1,
FirstName: 'John',
LastName: 'Heart',
CompanyName: 'Super Mart of the West',
Position: 'CEO',
OfficeNo: '901',
BirthDate: new Date(1964, 2, 16),
HireDate: new Date(1995, 0, 15),
Address: '351 S Hill St.',
City: 'Los Angeles',
State: 'CA',
Zipcode: '90013',
Phone: '(213) 555-9392',
Email: 'jheart@dx-email.com',
Skype: 'jheart_DX_skype',
};
export default {
getEmployee() {
return employee;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>